﻿function main_dl_example_Canvas_5() {

    var ctx = canvas_example_5.getContext("2d");
    var width = canvas_example_5.width;             // ширина поля для рисования
    var height = canvas_example_5.height;           // высота поля для рисования

    var rx = 50, ry = 50;                           // координаты шара
    var r = 25;                                     // радиус шара

    var xShift, yShift;                             // Описание дано в canvas_example_5.onmousedown

    // функция, рисующая шар
    function draw() {
        ctx.clearRect(0, 0, width, height);
        ctx.beginPath();
        ctx.arc(rx, ry, r, 0, 2 * Math.PI);
        ctx.fill();
    }

    // функция запускается при нажатии клавиши мыши
    canvas_example_5.onmousedown = function(e) {
        var m = mouseCoords(e);                     // получаем координаты курсора мыши
        var x = rx - m.x;                           // расстояние от центра шара до курсора по оси x
        var y = ry - m.y;                           // расстояние от центра шара до курсора по оси y
        var rLen2 = x * x + y * y;                  // квадрат расстояния между курсором и центром шара
        if (rLen2 <= r * r) {                       // если курсор нажал на шар
            xShift = rx - m.x;                      // сдвиг курсора относительно центра шара по x
            yShift = ry - m.y;                      // сдвиг курсора относительно центра шара по y
            canvas_example_5.onmousemove = mouseMove; // пока клавиша нажата - работает функция перемещения
        }
    };

    // функция запускается при отпускании клавиши мыши
    document.onmouseup = function() {
        canvas_example_5.onmousemove = null;        // когда клавиша отпущена - функции перемещения нету
    };

    // функция запускается при перемещении мыши (много раз, в каждый момент перемещения)
    // в нашем случае работает только с зажатой клавишей мыши
    function mouseMove(e) {
        var m = mouseCoords(e);                     // получаем координаты курсора мыши
        rx = m.x + xShift;
        ry = m.y + yShift;
        draw();
    }

    // функция возвращает координаты курсора мыши
    function mouseCoords(e) {
        var m = [];
        var rect = canvas_example_5.getBoundingClientRect();
        m.x = e.clientX - rect.left;
        m.y = e.clientY - rect.top;
        return m;
    }

    ctx.fillStyle="#6666ff";                        // цвет шара
    draw();

}